"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Queue = /** @class */ (function () {
    function Queue() {
        this.items = {};
        this.counter = 0;
        this.pointer = 0;
    }
    Queue.prototype.enqueue = function (element) {
        this.items[this.counter] = element;
        this.counter++;
    };
    Queue.prototype.dequeue = function () {
        if (this.is_empty())
            return undefined;
        var dequeuedElement = this.items[this.pointer];
        delete this.items[this.pointer];
        this.pointer++;
        return dequeuedElement;
    };
    Queue.prototype.peek = function () {
        if (this.is_empty())
            return undefined;
        return this.items[this.pointer];
    };
    Queue.prototype.size = function () {
        return this.counter - this.pointer;
    };
    Queue.prototype.is_empty = function () {
        return this.size() === 0;
    };
    Queue.prototype.toString = function () {
        if (this.is_empty())
            return '';
        var objectString = "" + this.items[this.pointer];
        for (var i = this.pointer + 1; i < this.counter; i++) {
            objectString += ", " + this.items[i];
        }
        return objectString;
    };
    Queue.prototype.clear = function () {
        this.items = {};
        this.counter = 0;
        this.pointer = 0;
    };
    return Queue;
}());
exports.default = new Queue();
//# sourceMappingURL=Queue.js.map