"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var path = require("path");
var CSV = require("fast-csv");
var toCSV = function (jsonFile, callback) {
    // Props
    var keys, api, csvData;
    // Read and parse json file
    var jsonData = JSON.parse(fs.readFileSync(jsonFile).toString());
    // Extract keys [column headers] from first element in jsonData
    keys = Object.keys(jsonData[0]);
    // csv Data
    csvData = [keys.join(',')]; // Headers as first element in array
    // Add the rest of the elements from jsonData
    jsonData.forEach(function (record) {
        return csvData.push(Object.values(record).join(','));
    });
    // Save to file
    var defaultSaveOptions = { filename: jsonFile };
    var save = function (_a) {
        var _b = (_a === void 0 ? defaultSaveOptions : _a).filename, filename = _b === void 0 ? jsonFile : _b;
        // Combine both keys and data from jsonData
        var mashup = __spreadArrays([
            keys
        ], jsonData);
        var file = path.basename("" + filename, '.json');
        CSV.writeToPath("./" + file + ".csv", mashup)
            .on('error', function (err) { return console.error(err); })
            .on('finish', function () { return console.log("Done. New file [ " + file + ".csv ] saved in current working directory"); });
    };
    // API 
    api = {
        data: csvData.join('\n'),
        save: save
    };
    // Pass API to callback
    callback(api);
};
exports.default = toCSV;
//# sourceMappingURL=to-csv.js.map